unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,Gauges;

type
  TBoundary = record
                 r1,r2,s1,s2:Double;
                 end;
  TControl_Panel = class(TForm)
    Start_Button: TButton;
    StaticText10: TStaticText;
    StaticText14: TStaticText;
    StaticText15: TStaticText;
    StaticText16: TStaticText;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    Exit_Button: TButton;
    StaticText1: TStaticText;
    EditBoundR1: TEdit;
    EditBoundR2: TEdit;
    EditBoundS1: TEdit;
    EditBoundS2: TEdit;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    EditRovX: TEdit;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    EditAlfaView: TEdit;
    EditBetaView: TEdit;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    StaticText9: TStaticText;
    EditAlfaLight: TEdit;
    EditBetaLight: TEdit;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    StaticText13: TStaticText;
    StaticText17: TStaticText;
    EditBackRed: TEdit;
    EditBackGreen: TEdit;
    EditBackBlue: TEdit;
    StaticText18: TStaticText;
    EditRightRed: TEdit;
    EditRightGreen: TEdit;
    EditRightBlue: TEdit;
    EditWrongRed: TEdit;
    EditWrongGreen: TEdit;
    EditWrongBlue: TEdit;
    StaticText19: TStaticText;
    EditSegm: TEdit;
    StaticText20: TStaticText;
    StaticText21: TStaticText;
    StaticText22: TStaticText;
    EditRovY: TEdit;
    EditRovZ: TEdit;
    StaticText23: TStaticText;
    StaticText24: TStaticText;
    EditD: TEdit;
    StaticText25: TStaticText;
    StaticText26: TStaticText;
    EditVel: TEdit;
    StaticText27: TStaticText;
    StaticText28: TStaticText;
    procedure Plocha(Sender: TObject);
    procedure Exit(Sender: TObject);
    procedure SetY2(Sender: TObject);
    procedure SetDraw3D(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;

implementation

uses Graph3D_2005;

Type TSegment = record A,B,C,D:T3DPoint;
                       Dist   :Double;
                       Vert,Horiz:Integer;
                end;

var BackRed,BackGreen,BackBlue,
    RightRed,RightGreen,RightBlue,
    WrongRed,WrongGreen,WrongBlue:Byte;
    RedSegm,GreenSegm,BlueSegm   :Byte;
    GreatOfSquare                :Byte;
    CountOfSegments              :LongInt;
    NoOfSegment                  :Longint;
    Segment                      :array [0..300000] of TSegment;


{$R *.DFM}
procedure TControl_Panel.Plocha(Sender: TObject);
var Code              :Integer;
    Index,i,j,Hi,Vi   :LongInt;
    hr,hs,Min,Max     :Double;
    Direct,Distance   :Double;
    f,ErrorReport:String;
    A,B,C,D    :T3DPoint;
    Podminka,Zmena   :Boolean;
    t,tosv,RovPas:Double;
    fx,fy,fz   :string;
    DistOfSegm :Double;
    VecU,VecV,VecW      :TVector;
    Express_fx,
    Express_fy,
    Express_fz  :TExpression;

  Procedure Setting;
  var numer:Double;
  begin
    Val(EditX1.Text,Numer,Code);Draw3D.X1:=Numer;
    Val(EditX2.Text,Numer,Code);Draw3D.X2:=Numer;
    Val(EditY1.Text,Numer,Code);Draw3D.Y1:=Numer;
    Val(EditY2.Text,Numer,Code);Draw3D.Y2:=Numer;
    Val(EditBoundR1.Text,Numer,Code);Draw3D.R1:=Numer;
    Val(EditBoundR2.Text,Numer,Code);Draw3D.R2:=Numer;
    Val(EditBoundS1.Text,Numer,Code);Draw3D.S1:=Numer;
    Val(EditBoundS2.Text,Numer,Code);Draw3D.S2:=Numer;
    Val(EditAlfaView.Text,Draw3D.AlfaView,Code);
    Val(EditBetaView.Text,Draw3D.BetaView,Code);
    Val(EditD.Text,Distance,Code);
    fx:=EditRovX.Text;
    fy:=EditRovY.Text;
    fz:=EditRovZ.Text;
    Val(EditAlfaLight.Text,Draw3D.AlfaLight,Code);
    Val(EditBetaLight.Text,Draw3D.BetaLight,Code);
    Val(EditBackRed.Text,BackRed,Code);
    Val(EditBackGreen.Text,BackGreen,Code);
    Val(EditBackBlue.Text,BackBlue,Code);
    Val(EditRightRed.Text,RightRed,Code);
    Val(EditRightGreen.Text,RightGreen,Code);
    Val(EditRightBlue.Text,RightBlue,Code);
    Val(EditWrongRed.Text,WrongRed,Code);
    Val(EditWrongGreen.Text,WrongGreen,Code);
    Val(EditWrongBlue.Text,WrongBlue,Code);
    Val(EditSegm.Text,CountOfSegments,Code);
    Val(EditVel.Text,GreatOfSquare,Code);
  end;  {Setting}

   procedure sort(Left,Right:LongInt);
   var i,j      :LongInt;
       Pivot    :Double;
       Trezor   :TSegment;
   begin
     i:=Left;j:=Right;
     pivot:=Segment[(Left+Right) div 2].Dist;
     repeat
     while Segment[i].Dist<pivot do inc(i);
     while Segment[j].Dist>pivot do dec(j);
     if i<=j then
              begin
                Trezor:=Segment[i];Segment[i]:=Segment[j];Segment[j]:=Trezor;
                inc(i);dec(j);
              end;
   until i>j;
   if Left<j then sort(Left,j);
   if Right>i then sort(i,Right);
   end;

 begin
    Setting;
    With Draw3D do
    begin
       Visible:=True;ClearImage(255,255,220);
       Scale(x1,x2,y1,y2);
       SetCenterProjection(AlfaView,BetaView,Distance,ObserverPoint);
       AlfaLight:=pi*AlfaLight/180;BetaLight:=pi/2-pi*BetaLight/180;
       DirectOfLight[1]:=cos(AlfaLight)*sin(AlfaLight);
       DirectOfLight[2]:=sin(AlfaLight)*sin(BetaLight);
       DirectOfLight[3]:=Cos(BetaLight);
       hr:=(r2-r1)/CountOfSegments/4;
       hs:=(s2-s1)/CountOfSegments;
     Express_fx:=PreCalc(fx,ErrorReport);
    if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
    Express_fy:=PreCalc(fy,ErrorReport);
    if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
    Express_fz:=PreCalc(fz,ErrorReport);
    if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
    r:=r1;NoOfSegment:=0;Hi:=0;
    Repeat
      s:=s1;Vi:=0;
      Repeat
         Segment[NoOfSegment].A[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegment].A[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegment].A[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegment].Dist:=
              Draw3D.MajorRay[1]*Segment[NoOfSegment].A[1]
             +Draw3D.MajorRay[2]*Segment[NoOfSegment].A[2]
             +Draw3D.MajorRay[3]*Segment[NoOfSegment].A[3];
         Segment[NoOfSegment].Vert:=Vi;
         Segment[NoOfSegment].Horiz:=Hi;

         s:=s+hs;
         Segment[NoOfSegment].B[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegment].B[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegment].B[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         r:=r+hr;
         Segment[NoOfSegment].C[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegment].C[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegment].C[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         s:=s-hs;
         Segment[NoOfSegment].D[1]:=PostCalc(Express_fx,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegment].D[2]:=PostCalc(Express_fy,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         Segment[NoOfSegment].D[3]:=PostCalc(Express_fz,ErrorReport);
         if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
         r:=r-hr;s:=s+hs;
         Vi:=succ(Vi);Inc(NoOfSegment);
      until s>s2;
      r:=r+hr;Hi:=succ(Hi);
    Until r>r2;
    Dec(NoOfSegment);
    Sort(0,NoOfSegment);
    for index:=0 to NoOfSegment do
    begin
      SetVector(Segment[index].B,Segment[index].C,VecU);
      SetVector(Segment[index].B,Segment[index].A,VecV);
      VectorProduct(VecU,VecV,VecW);
      SetVector(Segment[index].B,ObserverPoint,VecU);
      Direct:=CosAngle(VecU,VecW);
     if (odd(Segment[Index].Vert div GreatOfSquare)
     and odd(Segment[Index].Horiz div GreatOfSquare)) or
         (not odd(Segment[Index].Vert div GreatOfSquare)
     and not odd(Segment[Index].Horiz div GreatOfSquare))
       then begin
             if Direct>0
               then begin Red:=WrongRed;Green:=WrongGreen;Blue:=WrongBlue;end
               else begin Red:=255-WrongRed;Green:=255-WrongGreen;Blue:=255-WrongBlue;end;
             Direct:=CosAngle(VecW,DirectOfLight);
             if ((Direct<0) and (Red=255-WrongRed)) or
                ((Direct>0) and (Red=WrongRed))
               then begin
                     Direct:=Direct*Direct;
                     if (1.5*Direct+0.1)*Red<256
                            then Red:=Trunc((1.5*Direct+0.1)*Red)
                            else Red:=255;
                     if (1.5*Direct+0.1)*Green<256
                            then Green:=Trunc((1.5*Direct+0.1)*Green)
                            else Green:=255;
                     if (1.5*Direct+0.1)*Blue<256
                            then Blue:=Trunc((1.5*Direct+0.1)*Blue)
                            else Blue:=255;
                    end
               else begin Red:=Trunc(0.1*Red);Green:=Trunc(0.1*Green);Blue:=Trunc(0.1*Blue);end;
              FillTriangle(Segment[index].A,Segment[index].B,Segment[index].C,Red,Green,Blue);
              FillTriangle(Segment[index].C,Segment[index].D,Segment[index].A,Red,Green,Blue);
            end
       else begin
            if Direct>0
               then begin Red:=RightRed;Green:=RightGreen;Blue:=RightBlue;end
               else begin Red:=255-RightRed;Green:=255-RightGreen;Blue:=255-RightBlue;end;
             Direct:=CosAngle(VecW,DirectOfLight);
             if ((Direct<0) and (Red=255-RightRed)) or
                ((Direct>0) and (Red=RightRed))
               then begin
                     Direct:=Direct*Direct;
                     if (1.5*Direct+0.1)*Red<256
                            then Red:=Trunc((1.5*Direct+0.1)*Red)
                            else Red:=255;
                     if (1.5*Direct+0.1)*Green<256
                            then Green:=Trunc((1.5*Direct+0.1)*Green)
                            else Green:=255;
                     if (abs(1.5*Direct)+0.1)*Blue<256
                            then Blue:=Trunc((1.5*Direct+0.1)*Blue)
                            else Blue:=255;
                    end
               else begin Red:=Trunc(0.1*Red);Green:=Trunc(0.1*Green);Blue:=Trunc(0.1*Blue);end;
              FillTriangle(Segment[index].A,Segment[index].B,Segment[index].C,Red,Green,Blue);
              FillTriangle(Segment[index].C,Segment[index].D,Segment[index].A,Red,Green,Blue);
            end;
        if index mod 100 = 0
          then begin
               Image.Repaint;
               Application.ProcessMessages;
               end;
      end;
   end;
end;

procedure TControl_Panel.Exit(Sender: TObject);
begin
  Draw3D.Visible:=False;
  Halt;
end;


procedure TControl_Panel.SetY2(Sender: TObject);
var x1,x2,y1,y2:Double;
    Code:Integer;
    Vypis:String;
begin
   With Draw3D do
   begin
   Val(EditX1.Text,x1,Code);
   Val(EditX2.Text,x2,Code);
   Val(EditY1.Text,y1,Code);
   y2:=y1+(x2-x1)*ClientHeight/ClientWidth;
   Str(y2:4:2,Vypis);EditY2.Text:=Vypis;
   EditY2.Show;
   end;
end;


procedure TControl_Panel.SetDraw3D(Sender: TObject);
begin
  Application.CreateForm(TDraw3D, Draw3D);
  With Draw3D do
  begin
    ClientWidth:=500;ClientHeight:=500;
    InitImage(500,500);ClearImage(255,255,255);
    Left:=425;Top:=40;
    Caption:='Regular Texture';
    Visible:=True;
  end;
end;



end.
